/*
 * Written by Sean Kelly
 * Placed into Public Domain
 */

module std.c.fenv;

extern (C):

struct fenv_t
{
    c_ushort status;
    c_ushort control;
    c_ushort round;
    c_ushort reserved[2];
}

alias c_int fexcept_t;

enum
{
    FE_INVALID      = 1,
    FE_DENORMAL     = 2, // non-standard
    FE_DIVBYZERO    = 4,
    FE_OVERFLOW     = 8,
    FE_UNDERFLOW    = 0x10,
    FE_INEXACT      = 0x20,
    FE_ALL_EXCEPT   = 0x3F,
    FE_TONEAREST    = 0,
    FE_UPWARD       = 0x800,
    FE_DOWNWARD     = 0x400,
    FE_TOWARDZERO   = 0xC00,
}

private fenv_t _FE_DFL_ENV;
fenv_t* FE_DFL_ENV = &_FE_DFL_ENV;

void feraiseexcept(c_int excepts);
void feclearexcept(c_int excepts);

c_int fetestexcept(c_int excepts);
c_int feholdexcept(fenv_t* envp);

void fegetexceptflag(fexcept_t* flagp, c_int excepts);
void fesetexceptflag(fexcept_t* flagp, c_int excepts);

c_int fegetround();
c_int fesetround(c_int round);

void fegetenv(fenv_t* envp);
void fesetenv(fenv_t* envp);
void feupdateenv(fenv_t* envp);