# Makefile to build D runtime library dmdgc.lib for Win32
# Designed to work with \dm\bin\make.exe
# Targets:
#	make
#		Same as make unittest
#	make dmdgc.lib
#		Build dmdgc.lib
#	make clean
#		Delete unneeded files created by build process
#	make unittest
#		Build dmdgc.lib, build and run unit tests
# Notes:
#	This relies on LIB.EXE 8.00 or later, and MAKE.EXE 5.01 or later.

CP=copy /y

CFLAGS=-mn -6 -r -Igc
#CFLAGS=-g -mn -6 -r -Igc

DFLAGS=-release -O -inline
#DFLAGS=-g -release

TFLAGS=-O -inline
#TFLAGS=-g

CC=\bin\dm\bin\dmc
DC=\bin\dmd\bin\dmd

DOC=..\..\doc\dmdgc

.DEFAULT: .asm .c .cpp .d .html .obj

.asm.obj:
	$(CC) -c $*

.c.obj:
	$(CC) -c $(CFLAGS) $* -o$*.obj

.cpp.obj:
	$(CC) -c $(CFLAGS) $* -o$*.obj

.d.obj:
	$(DC) -c $(DFLAGS) $* -of$*.obj

.d.html:
     $(DC) -c -o- -version=DDoc -Df$*.html dmdgc.ddoc $*.d

targets : lib doc
dmdgc   : lib
lib     : dmdgc.lib
doc     : dmdgc.doc

######################################################

ALL_OBJS= \
    gc.obj \
    gcbits.obj \
    gcstats.obj \
    gcx.obj \
    win32.obj

######################################################

ALL_DOCS=

######################################################

dmdgc.lib : $(ALL_OBJS)
    del dmdgc.lib
	lib -c -n dmdgc.lib $(ALL_OBJS)

dmdgc.doc : $(ALL_DOCS)
#    mkdir $(DOC)
#    copy /y *.html $(DOC)\.
    @echo No documentation available.

######################################################

clean :
	del $(ALL_OBJS)
	del dmdgc.lib
	del $(ALL_DOCS)

install :
	$(CP) dmdgc*.lib ..\..\lib\.
